/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.attr.SRefreshRoleData
 *  fire.pb.buff.continual.BuffTimer
 *  fire.pb.buff.continual.ConstantlyBuff
 *  fire.pb.buff.continual.ConstantlyBuffConfig
 *  fire.pb.buff.continual.PeriodBuff
 *  fire.pb.effect.Module
 *  fire.pb.effect.Role
 *  fire.pb.skill.Result
 *  fire.pb.timer.ScheduledFutureMap
 *  mkdb.Procedure
 *  mkio.Protocol
 *  org.apache.log4j.Logger
 *  xbean.Buff
 *  xbean.BuffAgent
 */
package fire.pb.buff;

import fire.pb.attr.SRefreshRoleData;
import fire.pb.buff.BuffClashs;
import fire.pb.buff.BuffRoleImpl;
import fire.pb.buff.Module;
import fire.pb.buff.SBuffChangeResult;
import fire.pb.buff.continual.BuffTimer;
import fire.pb.buff.continual.ConstantlyBuff;
import fire.pb.buff.continual.ConstantlyBuffConfig;
import fire.pb.buff.continual.PeriodBuff;
import fire.pb.effect.Role;
import fire.pb.skill.Result;
import fire.pb.timer.ScheduledFutureMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import mkdb.Procedure;
import mkio.Protocol;
import org.apache.log4j.Logger;
import xbean.Buff;

public abstract class BuffAgent {
    public static final Logger logger = Logger.getLogger((String)"BATTLE");
    protected xbean.BuffAgent agent;
    protected int agentType;
    protected boolean readonly;

    public boolean canAddBuff(int buffId) {
        return this.checkCanAddBuff(buffId) == 0;
    }

    public int checkCanAddBuff(int buffId) {
        int conflictId = this.checkBuffClash(buffId);
        if (conflictId != 0) {
            return conflictId;
        }
        return this.checkBuffValid(buffId);
    }

    public int checkBuffClash(int buffOpId) {
        ConstantlyBuffConfig cfg;
        BuffClashs buffconflicts = Module.getInstance().getBuffClashs(buffOpId);
        if (buffconflicts == null) {
            return 0;
        }
        Set<Integer> existIds = this.getAllBuffBeans().keySet();
        int conflict = buffconflicts.checkBuffClash(existIds);
        if (conflict > 0) {
            return conflict;
        }
        int bufftype = 0;
        if (Module.isConstantlyBuff(buffOpId)) {
            cfg = Module.getInstance().getDefaultCBuffConfig(buffOpId);
            if (cfg == null) {
                return 0;
            }
        } else {
            return 0;
        }
        bufftype = cfg.getBuffType();
        buffconflicts = Module.getInstance().getBuffClashs(bufftype);
        if (buffconflicts == null) {
            return 0;
        }
        conflict = buffconflicts.checkBuffClash(existIds);
        return conflict;
    }

    public boolean canEffectBuff(int buffId) {
        return this.checkBuffValid(buffId) == 0;
    }

    public int checkBuffValid(int buffId) {
        ConstantlyBuffConfig cfg;
        BuffClashs buffconflicts = Module.getInstance().getBuffClashs(buffId);
        if (buffconflicts == null) {
            return 0;
        }
        Set<Integer> existIds = this.getAllBuffBeans().keySet();
        int invalid = buffconflicts.checkBuffInvalid(existIds);
        if (invalid > 0) {
            return invalid;
        }
        int bufftype = 0;
        if (Module.isConstantlyBuff(buffId)) {
            cfg = Module.getInstance().getDefaultCBuffConfig(buffId);
            if (cfg == null) {
                return 0;
            }
        } else {
            return 0;
        }
        bufftype = cfg.getBuffType();
        buffconflicts = Module.getInstance().getBuffClashs(bufftype);
        if (buffconflicts == null) {
            return 0;
        }
        invalid = buffconflicts.checkBuffInvalid(existIds);
        return invalid;
    }

    public List<Integer> getOverridedBuffIds(int buffId) {
        BuffClashs buffClashs = Module.getInstance().getBuffClashs(buffId);
        if (buffClashs == null) {
            return new ArrayList<Integer>();
        }
        return buffClashs.getOverridedBuffIds(this.getAllBuffBeans().keySet());
    }

    public boolean existBuff(int buffId) {
        ConstantlyBuffConfig conf = Module.getInstance().getDefaultCBuffConfig(buffId);
        if (conf == null || conf.getClassName() == null) {
            return false;
        }
        if (conf.getClassName().equals("fire.pb.buff.continual.NullBuff")) {
            return this.existState(buffId);
        }
        return this.existBuffBean(buffId);
    }

    public boolean existBuffByType(int type) {
        if (type < 1 || type >= 1000) {
            return false;
        }
        for (Integer buffId : this.agent.getBuffs().keySet()) {
            ConstantlyBuffConfig cfg = Module.getInstance().getDefaultCBuffConfig(buffId);
            if (!(type >= 100 ? type == cfg.getBuffType() : (type >= 10 ? type == cfg.getBuffType() / 10 : type >= 1 && type == cfg.getBuffType() / 100))) continue;
            return true;
        }
        return false;
    }

    public abstract boolean existState(int var1);

    public ConstantlyBuff getBuff(int buffId) {
        Buff buffbean = this.getBuffBean(buffId);
        if (buffbean == null) {
            return null;
        }
        ConstantlyBuff cbuff = Module.getInstance().createConstantlyBuff(buffbean);
        return cbuff;
    }

    public Buff getBuffBean(int buffId) {
        return (Buff)this.agent.getBuffs().get(buffId);
    }

    public Buff addBuffBean(Buff buffbean) {
        return this.agent.getBuffs().put(buffbean.getIndex(), buffbean);
    }

    public Buff removeBuffBean(int buffId) {
        return (Buff)this.agent.getBuffs().remove(buffId);
    }

    public boolean existBuffBean(int buffId) {
        return this.agent.getBuffs().containsKey(buffId);
    }

    public Map<Integer, Buff> getAllBuffBeans() {
        HashMap<Integer, Buff> buffbeans = new HashMap<Integer, Buff>();
        buffbeans.putAll(this.agent.getBuffs());
        return buffbeans;
    }

    public List<ConstantlyBuff> getRoundBuffs() {
        ArrayList<ConstantlyBuff> buffs = new ArrayList<ConstantlyBuff>();
        for (Map.Entry<Integer, Buff> buffentry : this.getAllBuffBeans().entrySet()) {
            if (buffentry.getValue().getRound() > 0) {
                ConstantlyBuff cbuff = Module.getInstance().createConstantlyBuff(buffentry.getValue());
                buffs.add(cbuff);
                continue;
            }
            ConstantlyBuffConfig cfg = Module.getInstance().getDefaultCBuffConfig(buffentry.getKey());
            if (cfg == null) continue;
            try {
                if (!Module.ROUND_BUFF_CLASS.isAssignableFrom(Class.forName(cfg.getClassName()))) continue;
                ConstantlyBuff cbuff = Module.getInstance().createConstantlyBuff(buffentry.getValue());
                buffs.add(cbuff);
            }
            catch (ClassNotFoundException e) {
                e.printStackTrace();
            }
        }
        return buffs;
    }

    public Result countDownWhileRoundEnd(List<ConstantlyBuff> buffs) {
        Result result = new Result(true);
        for (ConstantlyBuff buff : buffs) {
            buff.setRound(buff.getRound() - 1);
            if (buff.getRound() <= 0) {
                result.updateResult(this.removeCBuff(buff.getId()));
                continue;
            }
            result.addAddedBuff(buff);
        }
        return result;
    }

    public Result addCBuff(int buffTypeId) {
        ConstantlyBuff buff = Module.getInstance().createConstantlyBuff(buffTypeId);
        if (buff == null) {
            logger.error((Object)("Buff(ID: " + buffTypeId + ") is not exist."));
            return new Result(false);
        }
        return this.addCBuff(buff);
    }

    public Result addCBuff(int buffId, int round, long time) {
        ConstantlyBuff cbuff = Module.getInstance().createConstantlyBuff(buffId);
        if (cbuff == null) {
            logger.error((Object)("Buff(ID: " + buffId + ") is not exist."));
            return new Result(false);
        }
        cbuff.setRound(round);
        cbuff.setTime(time);
        return this.addCBuff(cbuff);
    }

    public Result addCBuff(ConstantlyBuff buff) {
        if (!this.canAddBuff(buff.getId())) {
            return new Result(false);
        }
        Result result = new Result(true);
        if (this.existBuff(buff.getId()) && !(result = this.processOverrideSelf(buff)).isSuccess()) {
            return result;
        }
        List<Integer> rmbuffIds = this.getOverridedBuffIds(buff.getId());
        for (int rmbuffId : rmbuffIds) {
            result.updateResult(this.removeCBuff(rmbuffId));
        }
        result.updateResult(buff.impact(this));
        if (result.isSuccess()) {
            this.addSceneState(buff.getBuffConfig());
        }
        return result;
    }

    public Result processOverrideSelf(ConstantlyBuff newbuff) {
        if (newbuff.getBuffConfig().getOverrideSelfType() == 0) {
            return this.removeCBuff(newbuff.getId());
        }
        if (newbuff.getBuffConfig().getOverrideSelfType() == 1 && newbuff.getBuffConfig().getOverrideAttrs() != null) {
            Iterator iterator = newbuff.getBuffConfig().getOverrideAttrs().iterator();
            while (iterator.hasNext()) {
                Float newAttr;
                int attrid = (Integer)iterator.next();
                Buff existedBuff = this.getBuffBean(newbuff.getId());
                Float existedAttr = (Float)existedBuff.getEffects().get(attrid);
                if (existedAttr == null) {
                    existedAttr = Float.valueOf(0.0f);
                }
                if ((newAttr = (Float)newbuff.getEffects().get(attrid)) == null) {
                    newAttr = Float.valueOf(0.0f);
                }
                if ((newAttr = Float.valueOf(existedAttr.floatValue() + newAttr.floatValue())).floatValue() == 0.0f) continue;
                newbuff.getEffects().put(attrid, newAttr);
            }
            return this.removeCBuff(newbuff.getId());
        }
        if (newbuff.getBuffConfig().getOverrideSelfType() == 2) {
            Iterator iterator = newbuff.getBuffConfig().getOverrideAttrs().iterator();
            while (iterator.hasNext()) {
                Float newAttr;
                int attrid = (Integer)iterator.next();
                Buff existedBuff = this.getBuffBean(newbuff.getId());
                Float existedAttr = (Float)existedBuff.getEffects().get(attrid);
                if (existedAttr == null) {
                    existedAttr = Float.valueOf(0.0f);
                }
                if ((newAttr = (Float)newbuff.getEffects().get(attrid)) == null) {
                    newAttr = Float.valueOf(0.0f);
                }
                if (!(Math.abs(existedAttr.floatValue()) > Math.abs(newAttr.floatValue()))) continue;
                newbuff.getEffects().put(attrid, existedAttr);
            }
            return this.removeCBuff(newbuff.getId());
        }
        return new Result(false);
    }

    public abstract void startBuffTimer(ConstantlyBuff var1);

    public boolean addCBuffWithSP(int buffTypeId) {
        ConstantlyBuff buff = Module.getInstance().createConstantlyBuff(buffTypeId);
        if (buff == null) {
            logger.error((Object)("Buff(ID: " + buffTypeId + ") is not exist."));
            return false;
        }
        return this.addCBuffWithSP(buff);
    }

    public boolean addCBuffWithSP(ConstantlyBuff buff) {
        Result result = this.addCBuff(buff);
        if (result == null || !result.isSuccess()) {
            return false;
        }
        this.psendSBuffChangeResult(result);
        return true;
    }

    public Result removeFighterCBuff(int buffId, int nfighterid) {
        if (this.readonly) {
            return new Result(false);
        }
        if (this.existBuff(buffId) && this.getBuffBean(buffId).getFighterkey() == nfighterid) {
            ConstantlyBuff buff = this.getBuff(buffId);
            Result result = buff.closure(this);
            if (result.isSuccess()) {
                this.removeSceneState(buff.getBuffConfig());
            }
            return result;
        }
        return new Result(false);
    }

    public Result removeCBuff(int buffId) {
        if (this.readonly) {
            return new Result(false);
        }
        if (this.existBuff(buffId)) {
            ConstantlyBuff buff = this.getBuff(buffId);
            Result result = buff.closure(this);
            if (result.isSuccess()) {
                this.removeSceneState(buff.getBuffConfig());
            }
            return result;
        }
        return new Result(false);
    }

    public Result removeTimeoutCBuff(int buffId) {
        if (this.readonly) {
            return new Result(false);
        }
        if (this.existBuff(buffId)) {
            ConstantlyBuff buff = this.getBuff(buffId);
            Result result = buff.closure(this, true);
            if (result.isSuccess()) {
                this.removeSceneState(buff.getBuffConfig());
            }
            return result;
        }
        return new Result(false);
    }

    public Result removeCBuff(int buffId, Map<Integer, Float> effects) {
        if (this.readonly) {
            return new Result(false);
        }
        if (this.existBuff(buffId)) {
            ConstantlyBuff buff = this.getBuff(buffId);
            for (Map.Entry<Integer, Float> effect : effects.entrySet()) {
                float newvalue;
                Float oldvalue = (Float)buff.getEffects().get(effect.getKey());
                if (oldvalue == null || !((newvalue = oldvalue.floatValue() + effect.getValue().floatValue()) < 0.0f)) continue;
                buff.getEffects().remove(effect.getKey());
            }
            if (buff.getEffects().size() == 0) {
                return buff.closure(this);
            }
            Result result = buff.impact(this);
            return result;
        }
        return new Result(false);
    }

    public boolean removeTimeoutCBuffWithSP(int buffId) {
        Result result = this.removeTimeoutCBuff(buffId);
        if (result == null || !result.isSuccess()) {
            return false;
        }
        this.psendSBuffChangeResult(result);
        return true;
    }

    public boolean removeCBuffWithSP(int buffId) {
        Result result = this.removeCBuff(buffId);
        if (result == null || !result.isSuccess()) {
            return false;
        }
        this.psendSBuffChangeResult(result);
        return true;
    }

    public boolean removeCBuffWithSP(int buffId, Map<Integer, Float> effects) {
        Result result = this.removeCBuff(buffId, effects);
        if (result == null || !result.isSuccess()) {
            return false;
        }
        this.psendSBuffChangeResult(result);
        return true;
    }

    public boolean removeCBuffWhileBattleEnd(int buffId) {
        this.agent.getBattleendclear().put(buffId, 1);
        return true;
    }

    public Result removeBuffsWhileBattleEnd() {
        if (this.readonly) {
            return new Result(false);
        }
        Result result = new Result(true);
        ArrayList<Integer> rmBuffIds = new ArrayList<Integer>();
        for (int buffId : this.getAllBuffBeans().keySet()) {
            try {
                ConstantlyBuffConfig cbuffconf = Module.getInstance().getDefaultCBuffConfig(buffId);
                if (cbuffconf.getClearType() != 0 && cbuffconf.getClearType() != 9 && cbuffconf.getClearType() != 8 && cbuffconf.getClearType() != 4 && cbuffconf.getClearType() != 5) continue;
                rmBuffIds.add(buffId);
            }
            catch (Exception e) {
                e.printStackTrace();
            }
        }
        for (int rmBuffId : rmBuffIds) {
            try {
                result.updateResult(this.removeCBuff(rmBuffId));
            }
            catch (Exception e) {
                e.printStackTrace();
            }
        }
        return result;
    }

    public boolean removeBuffsWhileBattleEndWithSP() {
        try {
            if (this.readonly) {
                return false;
            }
            Result result = this.removeBuffsWhileBattleEnd();
            if (result.isSuccess()) {
                this.psendSBuffChangeResult(result);
                return true;
            }
        }
        catch (Exception e) {
            e.printStackTrace();
        }
        return false;
    }

    public long getCBuffTime(int buffId) {
        if (this.readonly) {
            return -1L;
        }
        Long futureId = (Long)this.agent.getTimerfutures().get(buffId);
        if (futureId == null) {
            return -1L;
        }
        ScheduledFuture timerfuture = ScheduledFutureMap.getInstance().get(futureId.longValue());
        if (timerfuture == null) {
            return -1L;
        }
        long remaintime = timerfuture.getDelay(TimeUnit.MILLISECONDS);
        return remaintime;
    }

    public long updateCBuffTimingWithSP(int buffId, long addTime) {
        if (this.readonly) {
            return -1L;
        }
        ConstantlyBuff cbuff = this.getBuff(buffId);
        if (cbuff == null) {
            return -1L;
        }
        Long futureId = (Long)this.agent.getTimerfutures().get(buffId);
        if (futureId == null) {
            return -1L;
        }
        ScheduledFuture timerfuture = ScheduledFutureMap.getInstance().get(futureId.longValue());
        if (timerfuture == null) {
            return -1L;
        }
        long remaintime = timerfuture.getDelay(TimeUnit.MILLISECONDS);
        long newtime = remaintime + addTime;
        if (newtime < 0L) {
            newtime = 0L;
        }
        cbuff.setImpactTime(System.currentTimeMillis());
        cbuff.getBuffBean().setRemaintime(newtime);
        BuffTimer newtimer = this.getBuffTimer(buffId, newtime);
        if (newtimer.schedule()) {
            timerfuture.cancel(true);
            ScheduledFutureMap.getInstance().remove(futureId.longValue());
            this.agent.getTimerfutures().put(buffId, ScheduledFutureMap.getInstance().insert(newtimer.getFuture()));
            Result result = new Result(true);
            result.addAddedBuff(cbuff);
            this.psendSBuffChangeResult(result);
        } else {
            this.removeCBuffWithSP(buffId);
        }
        return newtime;
    }

    public Result processCBuff(int buffId) {
        ConstantlyBuff buff = this.getBuff(buffId);
        if (buff == null) {
            return new Result(false);
        }
        return buff.process(this);
    }

    public boolean processCBuffWithSP(int buffId) {
        ConstantlyBuff buff = this.getBuff(buffId);
        Result result = buff.process(this);
        if (result == null || !result.isSuccess()) {
            return false;
        }
        this.psendSBuffChangeResult(result);
        return true;
    }

    public boolean processCBuffWhileBattleEnd(int buffId) {
        this.agent.getBattleendclear().put(buffId, 2);
        return true;
    }

    public List<String> getBuffTipArgs(int buffId) {
        ArrayList<String> args = new ArrayList<String>();
        return args;
    }

    /*
     * Enabled force condition propagation
     * Lifted jumps to return sites
     */
    public static boolean processBuffTime(ConstantlyBuff cbuff, long now) {
        if (cbuff.getTime() <= 0L) {
            return true;
        }
        if (cbuff.getImpactTime() == 0L) return true;
        if (cbuff instanceof PeriodBuff) {
            PeriodBuff pbuff = (PeriodBuff)cbuff;
            if (pbuff.getPeriodCount() > 0) {
                long resumeTime = (long)pbuff.getPeriodCount() * pbuff.getPeriod() + pbuff.getInitialDelay() - (now - pbuff.getImpactTime());
                if (resumeTime <= 0L) return false;
                pbuff.setImpactTime(0L);
                pbuff.setInitialDelay(resumeTime % pbuff.getPeriod());
                pbuff.setPeriodCount((int)(resumeTime / pbuff.getPeriod()) + 1);
                return true;
            } else {
                long pastTime = now - pbuff.getImpactTime();
                if (pastTime <= pbuff.getInitialDelay()) {
                    pbuff.setInitialDelay(pbuff.getInitialDelay() - pastTime);
                } else {
                    pbuff.setInitialDelay(pbuff.getPeriod() - (pastTime - pbuff.getInitialDelay()) % pbuff.getPeriod());
                }
                pbuff.setImpactTime(0L);
            }
            return true;
        } else {
            long resumeTime = cbuff.getTime() - (now - cbuff.getImpactTime());
            if (resumeTime <= 0L) return false;
            cbuff.setImpactTime(0L);
            cbuff.setTime(resumeTime);
        }
        return true;
    }

    public abstract BuffTimer getBuffTimer(int var1, long var2);

    public abstract BuffTimer getBuffTimer(int var1, long var2, long var4);

    public abstract BuffTimer getBuffTimer(int var1, long var2, long var4, int var6);

    public abstract boolean psendSBuffChangeResult(Result var1);

    public abstract void addSceneState(ConstantlyBuffConfig var1);

    public abstract void removeSceneState(ConstantlyBuffConfig var1);

    protected abstract SBuffChangeResult getSBuffChangeResult(Result var1);

    public xbean.BuffAgent getAgent() {
        return this.agent;
    }

    public void setAgent(xbean.BuffAgent agent) {
        this.agent = agent;
    }

    public boolean isReadonly() {
        return this.readonly;
    }

    public void setReadonly(boolean readonly) {
        this.readonly = readonly;
    }

    public int getAgentType() {
        return this.agentType;
    }

    public void setAgentType(int agentType) {
        this.agentType = agentType;
    }

    public abstract Role getERole();

    public boolean examBuffsEffects() {
        if (!(this instanceof BuffRoleImpl)) {
            return true;
        }
        HashMap buffeffects = new HashMap();
        for (Buff xbuff : this.getAllBuffBeans().values()) {
            for (Map.Entry entry : xbuff.getEffects().entrySet()) {
                if (!fire.pb.effect.Module.isFightAttr((int)((Integer)entry.getKey() / 10 * 10))) continue;
                Float value = (Float)buffeffects.get(entry.getKey());
                if (value == null) {
                    buffeffects.put(entry.getKey(), entry.getValue());
                    continue;
                }
                buffeffects.put(entry.getKey(), Float.valueOf(value.floatValue() + ((Float)entry.getValue()).floatValue()));
            }
        }
        Map changedattrs = this.getERole().correctEffects(buffeffects);
        if (changedattrs != null && !changedattrs.isEmpty()) {
            Map clientAttrs = fire.pb.effect.Module.getClientAttrs((Map)changedattrs);
            if (clientAttrs.size() != 0) {
                Procedure.psendWhileCommit((long)((BuffRoleImpl)this).getRoleId(), (Protocol)new SRefreshRoleData((HashMap)clientAttrs));
            }
            return false;
        }
        return true;
    }
}

